VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7275
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   7275
   StartUpPosition =   3  'Windows-Standard
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   240
      Top             =   1200
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.PictureBox Picture2 
      Height          =   1695
      Left            =   4320
      ScaleHeight     =   1635
      ScaleWidth      =   1995
      TabIndex        =   3
      Top             =   120
      Width           =   2055
   End
   Begin VB.PictureBox Picture1 
      Height          =   1695
      Left            =   2040
      ScaleHeight     =   1635
      ScaleWidth      =   2115
      TabIndex        =   2
      Top             =   120
      Width           =   2175
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   375
      Left            =   1920
      TabIndex        =   1
      Top             =   2160
      Width           =   1935
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Text            =   "Combo1"
      Top             =   120
      Width           =   1815
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!


' "chgBPP" ndert die BitsPerPixel-Eigenschaft einer PictureBox.
'
' Bilder, die mit LoadPicture in eine PictureBox bertragen
' werden, passen die hierbei von VB benutzten OLE-Funktionen
' der aktuellen Bildschirmeinstellung an.
'
' Damit die Graphik-Tipps funktionieren, mu das Bild i.d.R. im
' 24-Bit-Format vorliegen. Dies wird von der Funktion chgBPP
' umgesetzt, die deshalb vor der eigentlichen Manipulation durch
' die Graphik-Tipp-Funktion ausgefhrt werden muss.
'
' Im hiesigen Beispiel wird das Bild von PictureBox1 nach PictureBox2
' kopiert. Fr die Anwendung im Zusammenhang mit den Grafik-Tipps
' ist nur Module1 ntig, und muss der Aufruf von chgBPP:
' CALL chgBPP(Picture1, Picture1, 24) lauten.

Option Explicit

' grerer Wert => grere Form
Private Const XYcm      As Long = 567&
Private Const Ftxt      As String = "Change BitsPerPixel"

' udt: Windows-Bitmap-Struktur
'      -> Einlesen der Bildinformationen
'         mit GDI_GetObject()

Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

' Einlesen von Informationen ber GDI-Objekte (z.B. Bilder)
Private Declare Function GetObjectA Lib "gdi32" _
    (ByVal hObject As Long, _
     ByVal nCount As Long, _
     ByRef lpObject As Any) As Long

Private Sub Combo1_Click()
    Combo1_Change
End Sub

Private Sub Form_Load()
    With Me
        .ScaleMode = vbTwips
        .Width = 12 * XYcm
        .Height = 7 * XYcm
        .Caption = Ftxt
    End With
    
    With Me.Combo1
        .AddItem 1
        .AddItem 4
        .AddItem 8
        .AddItem 16
        .AddItem 24
        .AddItem 32
        .ListIndex = 4
    End With

    Command1.Caption = "Bild laden"
End Sub

Private Sub Form_Resize()
    Dim dfw As Long
    Dim dfh As Long
    Dim tmp As Long
    
    dfw = Me.Width - Me.ScaleWidth
    dfh = Me.Height - Me.ScaleHeight
    tmp = (2 * 6) * XYcm + dfw
    
    If Me.Width < tmp Then Me.Width = tmp
    If Me.Height < 5 * XYcm Then Me.Height = 5 * XYcm
    
    ' Bild laden
    With Command1
        .Top = 0.25 * XYcm
        .Left = 0.25 * XYcm
        .Width = 2 * XYcm
        .Height = Combo1.Height
    End With
    
    ' BPP
    With Combo1
        .Top = 0.25 * XYcm
        .Left = 2.5 * XYcm
        .Width = 2 * XYcm
    End With
    
    With Picture1:
        .Top = Combo1.Height + 0.5 * XYcm
        .Left = 0.25 * XYcm
        .Width = (Me.Width - 0.5 * XYcm - 2 * dfw) / 2
        .Height = Me.Height - .Top - 0.25 * XYcm - dfh
    End With
    
    With Picture2:
        .Top = Picture1.Top
        .Left = Picture1.Width + 0.5 * XYcm
        .Width = Picture1.Width
        .Height = Picture1.Height
    End With
End Sub

Private Sub Form_Activate()
    Call Command1_Click
End Sub

Private Sub Combo1_Change()
    On Error Resume Next
    
    If chgBPP(Me.Picture1, Me.Picture2, Val(Combo1.Text)) Then
        Call shwBPP(Picture2)
    End If
    
    ' Me.Picture1.SetFocus
End Sub

' Bild laden
Private Sub Command1_Click()
    On Error Resume Next
    
    With CommonDialog1
        .CancelError = True
        .Flags = &H281800
        .Filter = "Bilder |*.bmp;*.jpg||"
        .ShowOpen
    
        If Err = 0 Then
            Set Picture1 = LoadPicture(.FileName)
            Call shwBPP(Picture1)
            Call Combo1_Change
        End If
    End With
    
    Me.Picture1.SetFocus
End Sub

Function shwBPP(pbx As PictureBox)
    Dim bmp    As BITMAP
    Dim txt    As String
    Dim I1     As Long
    
    With pbx
        .CurrentX = 0
        .CurrentY = 0
        .FontBold = True
        .ForeColor = vbBlack
        .FontSize = 15
    End With
    
    If GetObjectA(pbx.Picture.Handle, Len(bmp), bmp) <> 0 Then
        txt = "BitsPerPixel " & bmp.bmBitsPixel
    Else
        txt = "Fehler"
    End If
    
    pbx.Print txt
End Function
